IMPLEMENTATION MODULE OFiler;

(* By: Harrie F.A. de Leeuw *)
(* Part of 'Orbit' program  *)


(********************** IMPORT from non GEM-libraries *)
FROM SYSTEM             IMPORT ADR,
                               ADDRESS;
FROM M2Conversions      IMPORT ConvertToCardinal,
                               ConvertToInteger,
                               ConvertToReal,
                               ConvertCardinal,
                               ConvertReal;
FROM Strings            IMPORT InitStringModule,
                               String,
                               Length,
                               Concat,
                               Assign,
                               Pos,
                               Copy;
FROM InOut              IMPORT Done,
                               OpenOutputFile,
                               CloseOutput,
                               OpenInputFile,
                               CloseInput,
                               WriteString,
                               WriteLn,
                               WriteCard,
                               WriteInt,
                               ReadCard,
                               ReadInt,
                               Read;
FROM RealInOut          IMPORT WriteReal,
                               ReadReal;
FROM GEMDOS             IMPORT Delete;

(********************** IMPORT from specific ORBIT libraries *)
FROM OGEMGlobal         IMPORT SAVESA,
                               TRACK,
                               START,
                               SALOADED,
                               NSYES,
                               NSNO,
                               FNAME,
                               FYEAR,
                               FEPOCH,
                               FORBIT,
                               FMEANANO,
                               FMEANMOT,
                               FACCELER,
                               FINCLINA,
                               FECCENTR,
                               FARGPERI,
                               FRAAN,
                               FFREQUEN,
                               FOK,
                               FCANCEL,
                               SCALL,
                               SNORTH,
                               SWEST,
                               SHEIGHT,
                               SLOCALTI,
                               SOK,
                               SCANCEL,
                               ERRFIELD,
                               INERROK,
                               SatelliteNotSaved,
                               Touched,
                               TextAddr,
                               TedInfoAddr,
                               NotSavedTreeAddr,
                               SatelInTreeAddr,
                               StatInTreeAddr,
                               InputErrTreeAddr,
                               MenuTreeAddr,
                               HandleForm,
                               SatelliteActive,
                               ScanParamsActive;
FROM OStatInfo          IMPORT UpdateStatInfo,
                               StatInfoIsOpen;
FROM OSatelInfo         IMPORT UpdateSatelInfo,
                               SatelInfoIsOpen;

(*********************) IMPORT GEMAESbase;
FROM AESForms           IMPORT FormCenter,
                               FormDialogue,
                               FormDo,
                               FormAlert,
                               FileSelectorInput;
FROM AESObjects         IMPORT ObjectDraw,
                               ObjectChange;
FROM AESMenus           IMPORT MenuItemEnable;



VAR Temp:         SateData;
    TempStation:  StatData;
    PathName,
    SelName:      String;



PROCEDURE MakeFileName(VAR Dir,Sel,Tot: String);
VAR LastValid,Start,Position: CARDINAL;
    Bool: BOOLEAN;
    Hulp: String;
BEGIN
  Start:=0;
  Position:=Length(Dir)-1;
  Hulp:='\';
  REPEAT  
    LastValid:=Position;
    Bool:=Pos(Dir,Hulp,Start,Position);
    Start:=Position+1
  UNTIL Bool=FALSE;
  Copy(Dir,0,LastValid+1,Hulp);
  Concat(Hulp,Sel,Tot)
END MakeFileName;



PROCEDURE ReadSat(VAR SR:SateData);
VAR X:  INTEGER;
    Ch: CHAR;
BEGIN
  Read(Ch);
  X:=0;
  WHILE ORD(Ch)>=32 DO
    SR.Naam[X]:=Ch;
    INC(X);
    Read(Ch)
  END;
  SR.Naam[X]:=0C;
  ReadCard(SR.YJaar);
  ReadReal(SR.YDag);
  ReadCard(SR.YOmloop);
  ReadReal(SR.YMeanAnom);
  ReadReal(SR.YMeanMotion);
  ReadReal(SR.YAccMeanM);
  ReadReal(SR.YInclinatie);
  ReadReal(SR.YEccentr);
  ReadReal(SR.YArgPer);
  ReadReal(SR.YRaan);
  ReadReal(SR.Frekwentie)
END ReadSat;


PROCEDURE WriteSat(VAR SR:SateData);
BEGIN
  WriteString(SR.Naam);
  WriteLn;
  WriteCard(SR.YJaar,1);
  WriteLn;
  WriteReal(SR.YDag,20);
  WriteLn;
  WriteCard(SR.YOmloop,1);
  WriteLn;
  WriteReal(SR.YMeanAnom,20);
  WriteLn;
  WriteReal(SR.YMeanMotion,20);
  WriteLn;
  WriteReal(SR.YAccMeanM,20);
  WriteLn;
  WriteReal(SR.YInclinatie,20);
  WriteLn;
  WriteReal(SR.YEccentr,20);
  WriteLn;
  WriteReal(SR.YArgPer,20);
  WriteLn;
  WriteReal(SR.YRaan,20);
  WriteLn;
  WriteReal(SR.Frekwentie,20);
  WriteLn
END WriteSat;



PROCEDURE ReadStation;
VAR X:  INTEGER;
    Ch: CHAR;
BEGIN
  Read(Ch);
  X:=0;
  WHILE ORD(Ch)>=32 DO
    Station.EigenNaam[X]:=Ch;
    INC(X);
    Read(Ch)
  END;
  Station.EigenNaam[X]:=0C;
  ReadReal(Station.EigenNoord);
  ReadReal(Station.EigenWest);
  ReadReal(Station.EigenHoogte);
  ReadInt(Station.EigenTimeGMT)
END ReadStation;


PROCEDURE WriteStation;
BEGIN
  WriteString(Station.EigenNaam);
  WriteLn;
  WriteReal(Station.EigenNoord,20);
  WriteLn;
  WriteReal(Station.EigenWest,20);
  WriteLn;
  WriteReal(Station.EigenHoogte,20);
  WriteLn;
  WriteInt(Station.EigenTimeGMT,20);
  WriteLn
END WriteStation;



PROCEDURE SatNotSavedDialogue(VAR Continue: BOOLEAN);
BEGIN
  HandleForm(NotSavedTreeAddr,0);
  IF Touched=NSYES THEN
    Continue:=TRUE
  ELSE
    Continue:=FALSE
  END
END SatNotSavedDialogue;



PROCEDURE DisplayErrorField(VAR Str: ARRAY OF CHAR);
BEGIN
  TedInfoAddr:=ADDRESS(InputErrTreeAddr^[ERRFIELD].ObSpec);
  TextAddr:=TedInfoAddr^.TePText;
  Assign(TextAddr^,Str);
  HandleForm(InputErrTreeAddr,0)
END DisplayErrorField;



PROCEDURE LoadSatellite;
VAR Continue: BOOLEAN;
    TotalName: String;
BEGIN
  Continue:=TRUE;
  IF SatelliteNotSaved THEN
    SatNotSavedDialogue(Continue)
  END;
  IF Continue THEN
    Assign(PathName,'ORBIT.DAT\*.SAT');
    Assign(SelName,'.SAT');
    FileSelectorInput(ADR(PathName),ADR(SelName),Touched);
    IF Touched=1 THEN
      MakeFileName(PathName,SelName,TotalName);
      OpenInputFile(TotalName);
      IF Done THEN
        ReadSat(SatRec);
        CloseInput;
        MenuItemEnable(MenuTreeAddr,SAVESA,1);
        MenuItemEnable(MenuTreeAddr,TRACK,1);
        IF ~SatelInfoIsOpen THEN
          MenuItemEnable(MenuTreeAddr,SALOADED,1)
        END;
        IF ScanParamsActive THEN
          MenuItemEnable(MenuTreeAddr,START,1)
        END;
        SatelliteActive:=TRUE;
        SatelliteNotSaved:=FALSE;
        IF SatelInfoIsOpen THEN
          UpdateSatelInfo
        END
      ELSE
        Touched:=FormAlert(1,'[1][ |Satellite file not found!][Ok]')
      END
    END
  END
END LoadSatellite;



PROCEDURE SaveSatellite;
VAR TotalName: String;
BEGIN
  Assign(PathName,'ORBIT.DAT\*.SAT');
  Assign(SelName,'.SAT');
  FileSelectorInput(ADR(PathName),ADR(SelName),Touched);
  IF Touched=1 THEN
    MakeFileName(PathName,SelName,TotalName);
    OpenInputFile(TotalName);
    IF Done THEN
      CloseInput;
      Touched:=FormAlert(1,
                  '[1][ |Overwrite existing satellite file?][Cancel|Ok]');
      IF Touched=2 THEN
        OpenOutputFile(TotalName);
        WriteSat(SatRec);
        CloseOutput;
        SatelliteNotSaved:=FALSE
      END
    ELSE
      OpenOutputFile(TotalName);
      WriteSat(SatRec);
      CloseOutput;
      SatelliteNotSaved:=FALSE
    END
  END
END SaveSatellite;



PROCEDURE ClearStrings;
VAR Item:CARDINAL;
BEGIN
  FOR Item:=FNAME TO FFREQUEN DO
    TedInfoAddr:=ADDRESS(SatelInTreeAddr^[Item].ObSpec);
    TextAddr:=TedInfoAddr^.TePText;
    TextAddr^[0]:=0C
  END
END ClearStrings;



PROCEDURE ConvertToStrings;
VAR Str: String;

  PROCEDURE RealToString(R:REAL; Item:INTEGER);
  VAR HStr: ARRAY[0..20] OF CHAR;
  BEGIN
    TedInfoAddr:=ADDRESS(SatelInTreeAddr^[Item].ObSpec);
    TextAddr:=TedInfoAddr^.TePText;
    ConvertReal(R,15,-10,HStr);
    Assign(TextAddr^,HStr)
  END RealToString;

BEGIN (* ConvertToStrings *)
  TedInfoAddr:=ADDRESS(SatelInTreeAddr^[FNAME].ObSpec);
  TextAddr:=TedInfoAddr^.TePText;
  Assign(TextAddr^,Temp.Naam);
  TedInfoAddr:=ADDRESS(SatelInTreeAddr^[FYEAR].ObSpec);
  TextAddr:=TedInfoAddr^.TePText;
  ConvertCardinal(Temp.YJaar,1,Str);
  Copy(Str,Length(Str)-2,2,TextAddr^);
  RealToString(Temp.YDag,FEPOCH);
  TedInfoAddr:=ADDRESS(SatelInTreeAddr^[FORBIT].ObSpec);
  TextAddr:=TedInfoAddr^.TePText;
  ConvertCardinal(Temp.YOmloop,1,TextAddr^);
  RealToString(Temp.YMeanAnom,FMEANANO);
  RealToString(Temp.YMeanMotion,FMEANMOT);
  RealToString(Temp.YAccMeanM,FACCELER);
  RealToString(Temp.YInclinatie,FINCLINA);
  RealToString(Temp.YEccentr,FECCENTR);
  RealToString(Temp.YArgPer,FARGPERI);
  RealToString(Temp.YRaan,FRAAN);
  RealToString(Temp.Frekwentie,FFREQUEN)
END ConvertToStrings;


PROCEDURE ConvertToValues(VAR ErrField: INTEGER); (* 0 -> no error *)
VAR DoneOk: BOOLEAN;

  PROCEDURE CardinalConversion(Item: INTEGER; VAR Dest: CARDINAL);
  BEGIN
    TedInfoAddr:=ADDRESS(SatelInTreeAddr^[Item].ObSpec);
    TextAddr:=TedInfoAddr^.TePText;
    IF Length(TextAddr^)=0 THEN
      Dest:=0;
      DoneOk:=TRUE
    ELSE
      ConvertToCardinal(TextAddr^,DoneOk,Dest)
    END
  END CardinalConversion;

  PROCEDURE RealConversion(Item: INTEGER; VAR Dest: REAL);
  BEGIN
    TedInfoAddr:=ADDRESS(SatelInTreeAddr^[Item].ObSpec);
    TextAddr:=TedInfoAddr^.TePText;
    IF Length(TextAddr^)=0 THEN
      Dest:=0.0;
      DoneOk:=TRUE
    ELSE
      ConvertToReal(TextAddr^,DoneOk,Dest)
    END
  END RealConversion;

BEGIN (* ConvertToValues *)
  TedInfoAddr:=ADDRESS(SatelInTreeAddr^[FNAME].ObSpec);
  TextAddr:=TedInfoAddr^.TePText;
  IF Length(TextAddr^)=0 THEN
    DisplayErrorField('Satellite Name:   (No Name?)');
    ErrField:=FNAME
  ELSE
    Assign(Temp.Naam,TextAddr^);
    CardinalConversion(FYEAR,Temp.YJaar);
    IF ((~DoneOk) OR (Temp.YJaar<80)) THEN
      DisplayErrorField('Year of ref. epoch. (Must be >=1980)');
      ErrField:=FYEAR
    ELSE
      RealConversion(FEPOCH,Temp.YDag);
      IF ~DoneOk THEN
        DisplayErrorField('Decimal day# of epoch.');
        ErrField:=FEPOCH
      ELSE
        CardinalConversion(FORBIT,Temp.YOmloop);
        IF ~DoneOk THEN
          DisplayErrorField('Orbit# at epoch.');
          ErrField:=FORBIT
        ELSE
          RealConversion(FMEANANO,Temp.YMeanAnom);
          IF ~DoneOk THEN
            DisplayErrorField('Mean anomaly at epoch.');
            ErrField:=FMEANANO
          ELSE
            RealConversion(FMEANMOT,Temp.YMeanMotion);
            IF ~DoneOk THEN
              DisplayErrorField('Mean motion at epoch.');
              ErrField:=FMEANMOT
            ELSE
              RealConversion(FACCELER,Temp.YAccMeanM);
              IF ~DoneOk THEN
                DisplayErrorField('Acceleration of Mean Motion.');
                ErrField:=FACCELER
              ELSE
                RealConversion(FINCLINA,Temp.YInclinatie);
                IF ~DoneOk THEN
                  DisplayErrorField('Inclination at epoch.');
                  ErrField:=FINCLINA
                ELSE
                  RealConversion(FECCENTR,Temp.YEccentr);
                  IF ~DoneOk THEN
                    DisplayErrorField('Eccentricity at epoch.');
                    ErrField:=FECCENTR
                  ELSE
                    RealConversion(FARGPERI,Temp.YArgPer);
                    IF ~DoneOk THEN
                      DisplayErrorField('Argument of perigee at epoch.');
                      ErrField:=FARGPERI
                    ELSE
                      RealConversion(FRAAN,Temp.YRaan);
                      IF ~DoneOk THEN
                        DisplayErrorField('R.A.A.N. at epoch.');
                        ErrField:=FRAAN
                      ELSE
                        RealConversion(FFREQUEN,Temp.Frekwentie);
                        IF ~DoneOk THEN
                          DisplayErrorField('Frequency.');
                          ErrField:=FFREQUEN
                        ELSE
                          ErrField:=0
                        END
                      END
                    END
                  END
                END
              END
            END
          END
        END
      END
    END
  END
END ConvertToValues;



PROCEDURE NewSatellite;
VAR Continue: BOOLEAN;
    First,ErrFieldNr: INTEGER;
    Ready: BOOLEAN;
BEGIN
  Continue:=TRUE;
  IF SatelliteNotSaved THEN
    SatNotSavedDialogue(Continue)
  END;
  IF Continue THEN
    First:=FNAME;
    Ready:=FALSE;
    ClearStrings;
    REPEAT
      HandleForm(SatelInTreeAddr,First);
      IF Touched=FCANCEL THEN
        Ready:=TRUE
      ELSE
        ConvertToValues(ErrFieldNr);
        IF ErrFieldNr=0 THEN
          Ready:=TRUE
        ELSE
          First:=ErrFieldNr
        END
      END
    UNTIL Ready;
    IF Touched=FOK THEN
      SatRec:=Temp;
      MenuItemEnable(MenuTreeAddr,SAVESA,1);
      MenuItemEnable(MenuTreeAddr,TRACK,1);
      MenuItemEnable(MenuTreeAddr,SALOADED,1);
      IF ScanParamsActive THEN
        MenuItemEnable(MenuTreeAddr,START,1)
      END;
      SatelliteActive:=TRUE;
      SatelliteNotSaved:=TRUE;
      IF SatelInfoIsOpen THEN
        UpdateSatelInfo
      END
    END  
  END
END NewSatellite;



PROCEDURE ChangeSatellite;
VAR TotalName: String;
    AlertString: ARRAY[0..99] OF CHAR;
    First,ErrFieldNr: INTEGER;
    Ready: BOOLEAN;
BEGIN
  Assign(PathName,'ORBIT.DAT\*.SAT');
  Assign(SelName,'.SAT');
  FileSelectorInput(ADR(PathName),ADR(SelName),Touched);
  IF Touched=1 THEN
    MakeFileName(PathName,SelName,TotalName);
    OpenInputFile(TotalName);
    IF Done THEN
      ReadSat(Temp);
      CloseInput;
      ConvertToStrings;
      First:=FNAME;
      REPEAT
        HandleForm(SatelInTreeAddr,First);
        IF Touched=FCANCEL THEN
          Ready:=TRUE
        ELSE
          ConvertToValues(ErrFieldNr);
          IF ErrFieldNr=0 THEN
            Ready:=TRUE
          ELSE
            First:=ErrFieldNr
          END
        END
      UNTIL Ready;
      IF Touched=FOK THEN
        Ready:=FALSE;
        REPEAT
          OpenInputFile(TotalName);
          IF Done THEN
            CloseInput;
            OpenOutputFile(TotalName);
            WriteSat(Temp);
            CloseOutput;
            Ready:=TRUE
          ELSE
            Concat('[1][ |Put disk with "',TotalName,AlertString);
            Concat(AlertString,
               '"|in the drive, to make changes|permanent.][Ok|Cancel]',AlertString);
            Touched:=FormAlert(1,AlertString);
            IF Touched=2 THEN
              Ready:=TRUE
            END
          END
        UNTIL Ready
      END
    ELSE
      Touched:=FormAlert(1,'[1][ |Satellite file not found!][Ok]')
    END
  END
END ChangeSatellite;



PROCEDURE DeleteSatellite;
VAR TotalName,AlertString: String;
    DelBool: BOOLEAN;
BEGIN
  Assign(PathName,'ORBIT.DAT\*.SAT');
  Assign(SelName,'.SAT');
  FileSelectorInput(ADR(PathName),ADR(SelName),Touched);
  IF Touched=1 THEN
    MakeFileName(PathName,SelName,TotalName);
    OpenInputFile(TotalName);
    IF Done THEN
      CloseInput;
      Concat('[1][Delete ',SelName,AlertString);
      Concat(AlertString,'?][No|Yes]',AlertString);
      Touched:=FormAlert(1,AlertString);
      IF Touched=2 THEN
        DelBool:=Delete(TotalName);
        IF DelBool=FALSE THEN
          Touched:=FormAlert(1,
                '[1][Error deleting file!| |Check disk(s)!][Ok]')
        END
      END
    ELSE
      Touched:=FormAlert(1,
                '[1][ |This satellite file does not exist!][Ok]')
    END
  END
END DeleteSatellite;



PROCEDURE ClearStationStrings;
VAR Item: CARDINAL;
BEGIN
  FOR Item:=SCALL TO SLOCALTI DO
    TedInfoAddr:=ADDRESS(StatInTreeAddr^[Item].ObSpec);
    TextAddr:=TedInfoAddr^.TePText;
    TextAddr^[0]:=0C
  END
END ClearStationStrings;



PROCEDURE ConvStatToValues(VAR Field:INTEGER);
VAR DoneOk: BOOLEAN;

  PROCEDURE RealConversion(Item:INTEGER; VAR Dest:REAL);
  BEGIN
    TedInfoAddr:=ADDRESS(StatInTreeAddr^[Item].ObSpec);
    TextAddr:=TedInfoAddr^.TePText;
    IF Length(TextAddr^)=0 THEN
      Dest:=0.0;
      DoneOk:=TRUE
    ELSE
      ConvertToReal(TextAddr^,DoneOk,Dest)
    END
  END RealConversion;

BEGIN (* ConvStatToValues *)
  TedInfoAddr:=ADDRESS(StatInTreeAddr^[SCALL].ObSpec);
  TextAddr:=TedInfoAddr^.TePText;
  IF Length(TextAddr^)=0 THEN
    DisplayErrorField('Station Call.       (No Call?)');
    Field:=SCALL
  ELSE
    Assign(TempStation.EigenNaam,TextAddr^);
    RealConversion(SNORTH,TempStation.EigenNoord);
    IF ~DoneOk THEN
      DisplayErrorField('Latitude.  (North)');
      Field:=SNORTH
    ELSE
      RealConversion(SWEST,TempStation.EigenWest);
      IF ~DoneOk THEN
        DisplayErrorField('Longitude.  (West)');
        Field:=SWEST
      ELSE
        RealConversion(SHEIGHT,TempStation.EigenHoogte);
        IF ~DoneOk THEN
          DisplayErrorField('Heigth in meters.');
          Field:=SHEIGHT
        ELSE
          TedInfoAddr:=ADDRESS(StatInTreeAddr^[SLOCALTI].ObSpec);
          TextAddr:=TedInfoAddr^.TePText;
          IF Length(TextAddr^)=0 THEN
            TempStation.EigenTimeGMT:=0;
            Field:=0
          ELSE
            ConvertToInteger(TextAddr^,DoneOk,TempStation.EigenTimeGMT);
            IF ~DoneOk THEN
              DisplayErrorField('Local time - GMT   (Hrs)');
              Field:=SLOCALTI
            ELSE
              Field:=0
            END
          END
        END
      END
    END
  END
END ConvStatToValues;



PROCEDURE ChangeStation;
VAR First,ErrFieldNr: INTEGER;
    Ready: BOOLEAN;
BEGIN
  First:=SCALL;
  Ready:=FALSE;
  ClearStationStrings;
  REPEAT
    HandleForm(StatInTreeAddr,First);
    IF Touched=SCANCEL THEN
      Ready:=TRUE
    ELSE
      ConvStatToValues(ErrFieldNr);
      IF ErrFieldNr=0 THEN
        Ready:=TRUE;
        Station:=TempStation;
        IF StatInfoIsOpen THEN
          UpdateStatInfo
        END
      ELSE
        First:=ErrFieldNr
      END
    END
  UNTIL Ready;
  IF Touched=SOK THEN
    Ready:=FALSE;
    REPEAT
      OpenInputFile('ORBIT.DAT\Station.ORB');
      IF Done THEN
        CloseInput;
        OpenOutputFile('ORBIT.DAT\Station.ORB');
        WriteStation;
        CloseOutput;
        Ready:=TRUE
      ELSE
        Touched:=FormAlert(1,'[1][ |"Station.ORB" not found!][Create|Retry|Cancel]');
        CASE Touched OF
          1: OpenOutputFile('ORBIT.DAT\Station.ORB');
             WriteStation;
             CloseOutput;
             Ready:=TRUE        |
          3: Ready:=TRUE        |
        ELSE
          (* Retry *)
        END
      END
    UNTIL Ready
  END
END ChangeStation;



PROCEDURE LoadStation;
BEGIN
  OpenInputFile('ORBIT.DAT\Station.ORB');
  IF Done THEN
    ReadStation;
    CloseInput
  ELSE
    REPEAT
      ChangeStation;
      OpenInputFile('ORBIT.DAT\Station.ORB');
      IF ~Done THEN
        Touched:=FormAlert(1,'[1][Station data must be defined!| |Try again!][Ok]')
      END
    UNTIL Done;
    CloseInput
  END
END LoadStation;



BEGIN (* OFiler *)
  InitStringModule (* Why can't it do this itself? *)
END OFiler.
