IMPLEMENTATION MODULE OOutSave;

(* By: Harrie F.A. de Leeuw *)
(* Part of 'Orbit' program  *)


FROM SYSTEM             IMPORT ADR;

(********************** IMPORT from Orbit specific libraries *)
FROM OOutWindow         IMPORT OutWindowHandle;
FROM OGEMGlobal         IMPORT WorkstationHandle;
FROM OXBIOS             IMPORT ScreenAddress;

(*********************) IMPORT GEMAESbase;
FROM AESWindows         IMPORT WindowUpdate,
                               WindowGet;
FROM AESGraphics        IMPORT GrafMouseKeyboardState;

(*********************) IMPORT GEMVDIbase;
FROM VDIEscapes         IMPORT RemoveCursor,
                               DisplayCursor;
FROM VDIRasters         IMPORT CopyRasterOpaque;



TYPE SaveArea= ARRAY[0..28879] OF CHAR;

VAR Sav:                SaveArea;
    SavPoint:           POINTER TO SaveArea;
    MFDBscreen,
    MFDBsav:            ARRAY[1..10] OF INTEGER;
    X,Y,W,H,
    MouseX,
    MouseY,
    Dum:                INTEGER;
    PxyArray:           GEMVDIbase.PxyArrayType;
    BigPxy:             GEMVDIbase.BigPxyArrayType;



PROCEDURE SaveOutput;
BEGIN
  WindowGet(OutWindowHandle,GEMAESbase.WorkXYWH,X,Y,W,H);
  BigPxy[0]:=X;
  BigPxy[1]:=Y;
  BigPxy[2]:=X+W-1;
  BigPxy[3]:=Y+H-1;
  BigPxy[4]:=0;
  BigPxy[5]:=0;
  BigPxy[6]:=W-1;
  BigPxy[7]:=H-1;
  GrafMouseKeyboardState(MouseX,MouseY,Dum,Dum);
  RemoveCursor(WorkstationHandle);
  CopyRasterOpaque(WorkstationHandle,3,BigPxy,ADR(MFDBscreen),ADR(MFDBsav));
  DisplayCursor(WorkstationHandle,MouseX,MouseY)
END SaveOutput;


PROCEDURE UpdateOutput;
VAR XWork,YWork: INTEGER;
BEGIN
  WindowGet(OutWindowHandle,GEMAESbase.WorkXYWH,XWork,YWork,Dum,Dum);
  GrafMouseKeyboardState(MouseX,MouseY,Dum,Dum);
  RemoveCursor(WorkstationHandle);
  WindowUpdate(GEMAESbase.BeginUpdate);
  WindowGet(OutWindowHandle,GEMAESbase.FirstXYWH,X,Y,W,H);
  WHILE W#0 DO
    IF ((X<640) & (Y<400)) THEN
      IF (X+W)>640 THEN
        W:=640-X
      END;
      IF (Y+H)>400 THEN
        H:=400-Y
      END;
      BigPxy[0]:=X-XWork;
      BigPxy[1]:=Y-YWork;
      BigPxy[2]:=X-XWork+W-1;
      BigPxy[3]:=Y-YWork+H-1;
      BigPxy[4]:=X;
      BigPxy[5]:=Y;
      BigPxy[6]:=X+W-1;
      BigPxy[7]:=Y+H-1;
      CopyRasterOpaque(WorkstationHandle,3,BigPxy,
                                        ADR(MFDBsav),ADR(MFDBscreen))
    END;
    WindowGet(OutWindowHandle,GEMAESbase.NextXYWH,X,Y,W,H)
  END;
  WindowUpdate(GEMAESbase.EndUpdate);
  DisplayCursor(WorkstationHandle,MouseX,MouseY)
END UpdateOutput;


BEGIN
  MFDBscreen[1]:=INTEGER(LONGCARD(ScreenAddress()) DIV 10000H);
  MFDBscreen[2]:=INTEGER(LONGCARD(ScreenAddress()) MOD 10000H);
  MFDBscreen[3]:=640;
  MFDBscreen[4]:=400;
  MFDBscreen[5]:=40;
  MFDBscreen[6]:=0;
  MFDBscreen[7]:=1;
  SavPoint:=ADR(Sav);
  MFDBsav[1]:=INTEGER(LONGCARD(SavPoint) DIV 10000H);
  MFDBsav[2]:=INTEGER(LONGCARD(SavPoint) MOD 10000H);
  MFDBsav[3]:=640;
  MFDBsav[4]:=361;
  MFDBsav[5]:=40;
  MFDBsav[6]:=0;
  MFDBsav[7]:=1
END OOutSave.
