IMPLEMENTATION MODULE OThresIn;

(* By: Harrie F.A. de Leeuw *)
(* Part of 'Orbit' program  *)



(********************** IMPORT from non GEM libraries *)
FROM SYSTEM             IMPORT ADDRESS;
FROM Strings            IMPORT Assign,
                               Length;
FROM M2Conversions      IMPORT ConvertToReal,
                               ConvertReal;

(********************** IMPORT from specific ORBIT libraries *)
FROM OGEMGlobal         IMPORT Touched,
                               MenuTreeAddr,
                               InputErrTreeAddr,
                               TedInfoAddr,
                               TextAddr,
                               SetElevThresTree,
                               SetLittleThresTree,
                               ELEVTHRE,
                               ELEVCANC,
                               ELEVOK,
                               LITTTHRE,
                               LITTCANC,
                               LITTOK,
                               ERRFIELD,
                               HandleForm;
FROM OrbGlobal          IMPORT ShowLowElevation,
                               ShowLittleChanges,
                               ElevationThres,
                               LittleChangesThres;



PROCEDURE DisplayErrorField(VAR Str: ARRAY OF CHAR);
BEGIN
  TedInfoAddr:=ADDRESS(InputErrTreeAddr^[ERRFIELD].ObSpec);
  TextAddr:=TedInfoAddr^.TePText;
  Assign(TextAddr^,Str);
  HandleForm(InputErrTreeAddr,0)
END DisplayErrorField;



PROCEDURE GetElevationThres;
VAR HStr:          ARRAY[0..9] OF CHAR;
    DoneOk,
    Ready:         BOOLEAN;
    TempElevThres: REAL;
BEGIN
  TedInfoAddr:=ADDRESS(SetElevThresTree^[ELEVTHRE].ObSpec);
  TextAddr:=TedInfoAddr^.TePText;
  ConvertReal(ElevationThres,10,2,HStr);
  Assign(TextAddr^,HStr);  
  Ready:=FALSE;
  REPEAT
    HandleForm(SetElevThresTree,ELEVTHRE);
    IF Touched=ELEVCANC THEN
      Ready:=TRUE
    ELSE
      TedInfoAddr:=ADDRESS(SetElevThresTree^[ELEVTHRE].ObSpec);
      TextAddr:=TedInfoAddr^.TePText;
      IF Length(TextAddr^)=0 THEN
        TempElevThres:=0.0;
        DoneOk:=TRUE
      ELSE
        ConvertToReal(TextAddr^,DoneOk,TempElevThres)
      END;
      IF ~DoneOk THEN
        DisplayErrorField('Elevation Threshold.')
      ELSE
        Ready:=TRUE
      END
    END
  UNTIL Ready;
  IF Touched=ELEVOK THEN
    ElevationThres:=TempElevThres
  END
END GetElevationThres;


PROCEDURE GetLittleChangesThres;
VAR HStr:          ARRAY[0..9] OF CHAR;
    DoneOk,
    Ready:         BOOLEAN;
    TempLittThres: REAL;
BEGIN
  TedInfoAddr:=ADDRESS(SetLittleThresTree^[LITTTHRE].ObSpec);
  TextAddr:=TedInfoAddr^.TePText;
  ConvertReal(LittleChangesThres,10,2,HStr);
  Assign(TextAddr^,HStr);  
  Ready:=FALSE;
  REPEAT
    HandleForm(SetLittleThresTree,LITTTHRE);
    IF Touched=LITTCANC THEN
      Ready:=TRUE
    ELSE
      TedInfoAddr:=ADDRESS(SetLittleThresTree^[LITTTHRE].ObSpec);
      TextAddr:=TedInfoAddr^.TePText;
      IF Length(TextAddr^)=0 THEN
        TempLittThres:=0.0;
        DoneOk:=TRUE
      ELSE
        ConvertToReal(TextAddr^,DoneOk,TempLittThres)
      END;
      IF ~DoneOk THEN
        DisplayErrorField('Little Changes Threshold.')
      ELSE
        Ready:=TRUE
      END
    END
  UNTIL Ready;
  IF Touched=LITTOK THEN
    LittleChangesThres:=ABS(TempLittThres)
  END
END GetLittleChangesThres;



BEGIN (* OThresIn *)
  ShowLowElevation:=TRUE;
  ElevationThres:=0.0;
  ShowLittleChanges:=TRUE;
  LittleChangesThres:=0.1
END OThresIn.
