IMPLEMENTATION MODULE OTimeDate;

(* By: Harrie F.A. de Leeuw *)
(* Part of 'Orbit' program  *)


(********************** IMPORT from non GEM libraries *)
FROM SYSTEM             IMPORT ADDRESS;
FROM Strings            IMPORT String,
                               Concat,
                               Copy,
                               Assign,
                               Length;
FROM M2Conversions      IMPORT ConvertToCardinal,
                               ConvertCardinal;

(********************** IMPORT from specific ORBIT libraries *)
FROM OGEMGlobal         IMPORT DATE,
                               TIME,
                               TIMEOK,
                               TIMECANC,
                               ERRFIELD,
                               Touched,
                               MenuTreeAddr,
                               InputErrTreeAddr,
                               TimeDateTreeAddr,
                               TedInfoAddr,
                               Text,
                               TextAddr,
                               HandleForm;
FROM OClock             IMPORT TimeRecord,
                               ReadTime,
                               WriteTime;


VAR TempTR: TimeRecord;


PROCEDURE DisplayErrorField(VAR Str: ARRAY OF CHAR);
BEGIN
  TedInfoAddr:=ADDRESS(InputErrTreeAddr^[ERRFIELD].ObSpec);
  TextAddr:=TedInfoAddr^.TePText;
  Assign(TextAddr^,Str);
  HandleForm(InputErrTreeAddr,0)
END DisplayErrorField;


PROCEDURE ConvToStrings;
VAR S,Str: String;

  PROCEDURE TwoDigits(Val:CARDINAL);
  VAR St: String;
  BEGIN
    ConvertCardinal(Val,3,St);
    Copy(St,Length(St)-2,2,S);
    IF S[0]=' ' THEN
      S[0]:='0'
    END
  END TwoDigits;

BEGIN
  ReadTime(TempTR);
  TwoDigits(TempTR.Day);
  Assign(Str,S);
  TwoDigits(TempTR.Month);
  Concat(Str,S,Str);
  TwoDigits(TempTR.Year);
  Concat(Str,S,Str);
  TedInfoAddr:=ADDRESS(TimeDateTreeAddr^[DATE].ObSpec);
  TextAddr:=TedInfoAddr^.TePText;
  Assign(TextAddr^,Str);
  TwoDigits(TempTR.Hour);
  Assign(Str,S);
  TwoDigits(TempTR.Min);
  Concat(Str,S,Str);
  TwoDigits(TempTR.Sec);
  Concat(Str,S,Str);
  TedInfoAddr:=ADDRESS(TimeDateTreeAddr^[TIME].ObSpec);
  TextAddr:=TedInfoAddr^.TePText;
  Assign(TextAddr^,Str)
END ConvToStrings;



PROCEDURE ConvToValues(VAR ErrField:INTEGER);
VAR DoneOk: BOOLEAN;
    C: CARDINAL;

  PROCEDURE ConvTwo(S:Text; Index:CARDINAL; VAR Value: CARDINAL);
  VAR St: String;
  BEGIN
    Copy(S,Index,2,St);
    ConvertToCardinal(St,DoneOk,Value)
  END ConvTwo;

BEGIN
  TedInfoAddr:=ADDRESS(TimeDateTreeAddr^[DATE].ObSpec);
  TextAddr:=TedInfoAddr^.TePText;
  ConvTwo(TextAddr^,0,C);
  IF ~((C<=31) & (C#0) & DoneOk) THEN
    DisplayErrorField('Date:   Day must be 1..31');
    ErrField:=DATE
  ELSE
    TempTR.Day:=C;
    ConvTwo(TextAddr^,2,C);
    IF ~((C<=12) & (C#0) & DoneOk) THEN
      DisplayErrorField('Date:   Month must be 1..12');
      ErrField:=DATE
    ELSE
      TempTR.Month:=C;
      ConvTwo(TextAddr^,4,C);
      IF ~((C>=80) & DoneOk) THEN
        DisplayErrorField('Date:   Year must be 80..99');
        ErrField:=DATE
      ELSE
        TempTR.Year:=C;
        TedInfoAddr:=ADDRESS(TimeDateTreeAddr^[TIME].ObSpec);
        TextAddr:=TedInfoAddr^.TePText;
        ConvTwo(TextAddr^,0,C);
        IF ~((C<=23) & DoneOk) THEN
          DisplayErrorField('Time:   Hours must be 0..23');
          ErrField:=TIME
        ELSE
          TempTR.Hour:=C;
          ConvTwo(TextAddr^,2,C);
          IF ~((C<=59) & DoneOk) THEN
            DisplayErrorField('Time:   Minutes must be 0..59');
            ErrField:=TIME
          ELSE
            TempTR.Min:=C;
            ConvTwo(TextAddr^,4,C);
            IF ~((C<=59) & DoneOk) THEN
              DisplayErrorField('Time:   Seconds must be 0..59');
              ErrField:=TIME
            ELSE
              TempTR.Sec:=C;
              ErrField:=0
            END
          END
        END
      END
    END
  END
END ConvToValues;



PROCEDURE SetSystemTimeAndDate;
VAR First,ErrFieldNr: INTEGER;
    Ready: BOOLEAN;
BEGIN
  ConvToStrings;
  Ready:=FALSE;
  First:=DATE;
  REPEAT
    HandleForm(TimeDateTreeAddr,First);
    IF Touched=TIMECANC THEN
      Ready:=TRUE
    ELSE
      ConvToValues(ErrFieldNr);
      IF ErrFieldNr=0 THEN
        Ready:=TRUE
      ELSE
        First:=ErrFieldNr
      END
    END
  UNTIL Ready;
  IF Touched=TIMEOK THEN
    WriteTime(TempTR)
  END
END SetSystemTimeAndDate;


END OTimeDate.
